<?xml version="1.0" encoding="iso-8859-1"?>
<?data type="record"?>
<?data table="album"?>

<!-- =======================================================================================
This template works with CATweb.  It generates a page similar to AlbumBrowse.  
The template is compatible with the CATraxx Explorer.

This template should be copied to the Explorer Templates directory.

Requires wz_tooltip.js to be in folder catweb\catraxx.
See http://www.walterzorn.com/tooltip/tooltip_e.htm for additional information  

Author: LotsOCds@gmail.com
Revision: 30MAY2008

Works with:
CATraxx v8.10
CATweb v1.80
wz_tooltips.js v5.11

======================================================================================= -->
 
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>

<xsl:include href="Common.xsl"/>

<!--===========================================================================
You may edit the ToolTipCommands that are passed to wz_tooltips.js.  
See http://www.walterzorn.com/tooltip/tooltip_e.htm for additional information 
===============================================================================--> 
<xsl:param name="ToolTipCommands">, WIDTH, 0, OFFSETY, 0, LEFT, false, STICKY, true, CLOSEBTN, true, CLICKCLOSE, false, SHADOW, true, FADEIN, 400, FADEOUT, 400</xsl:param>

<!--===========================================================================
These variables set the widths of the credits tables in the tooltip.  Adjust them if necessary. 
===============================================================================--> 
<xsl:variable name="AlbumCreditsWidth" select="'750px'"/>
<xsl:variable name="TrackCreditsWidth" select="'100%'"/>


<xsl:variable name="doctitle">
  <xsl:call-template name="format-artist">
    <xsl:with-param name="artists" select="/data/record/albumdata/artists"/>
    <xsl:with-param name="hyperlink" select="'False'"/>
  </xsl:call-template>	
  <xsl:text> / </xsl:text>
  <xsl:value-of select="/data/record/albumdata/title"/>
</xsl:variable>

<xsl:template match="/">
  <HTML>
  <HEAD>
    <TITLE><xsl:value-of select="$doctitle"/></TITLE>  
    <LINK REL="stylesheet" TYPE="text/css" HREF="style.css"/>
  </HEAD>
  <BODY>
    <script type="text/javascript" src="wz_tooltip.js"></script> 
    <xsl:apply-templates select="data/record/albumdata"/>
    <xsl:if test="data/@dataserver='Yes'">
      <xsl:apply-templates select="data/record/albumdata" mode="tooltip"/>
      <xsl:apply-templates select="data/record/trackdata/item/side/track" mode="tooltip"/>
    </xsl:if>
  </BODY>  
  </HTML>
</xsl:template>

<xsl:template match="albumdata">
  <TABLE CLASS="pageheadingrecord" CELLSPACING="0" CELLPADDING="4">          
    <TR> 
      <TD CLASS="pageheadingrecord">
        <xsl:call-template name="format-artist">
          <xsl:with-param name="artists" select="artists"/>
          <xsl:with-param name="hyperlink" select="'False'"/>
        </xsl:call-template>,
        <xsl:value-of select="title"/>
        <xsl:text> </xsl:text>
        (<xsl:value-of select="playingtime"/>)
      </TD>
    </TR>
  </TABLE>
  <BR/>

  <!-- =========================================================================================== -->
  <!-- CATraxx does a much better job of image resizing images than the typical browser.  If image 
       quality is poor in the browser, try changing '/filename' to '/thumbnail' and (re)sizing
       all CATraxx thumnails to 100x100.  That way the browser will be displaying the actual
       image.                                                                                      -->
  <!-- =========================================================================================== -->
  <TABLE CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
    <TR>
      <!-- Column 1: Cover -->
      <xsl:if test="image1/filename!='' or image2/filename!='' or image3/filename!='' or
        image4/filename!='' or image5/filename!='' or image6/filename!='' or
        image7/filename!='' or image8/filename!='' or image9/filename!=''">           
      <TD VALIGN="TOP" WIDTH="100">        
        <xsl:if test="image1/filename!=''">
          <A HREF="Album_Image1.xsl?AlbumID={albumid}"><IMG BORDER="0" ALIGN="TOP" WIDTH="100" SRC="{image1/filename}"/></A>
          <xsl:text> </xsl:text>
        </xsl:if>
        <xsl:if test="image2/filename!=''">
          <A HREF="Album_Image2.xsl?AlbumID={albumid}"><IMG BORDER="0" ALIGN="TOP" WIDTH="100" SRC="{image2/filename}"/></A>
          <xsl:text> </xsl:text>
        </xsl:if>
        <xsl:if test="image3/filename!=''">
          <A HREF="Album_Image3.xsl?AlbumID={albumid}"><IMG BORDER="0" ALIGN="TOP" WIDTH="100" SRC="{image3/filename}"/></A>
          <xsl:text> </xsl:text>
        </xsl:if> 
        <xsl:if test="image4/filename!=''">
          <A HREF="Album_Image4.xsl?AlbumID={albumid}"><IMG BORDER="0" ALIGN="TOP" WIDTH="100" SRC="{image4/filename}"/></A>
          <xsl:text> </xsl:text>
        </xsl:if> 
        <xsl:if test="image5/filename!=''">
          <A HREF="Album_Image5.xsl?AlbumID={albumid}"><IMG BORDER="0" ALIGN="TOP" WIDTH="100" SRC="{image5/filename}"/></A>
          <xsl:text> </xsl:text>
        </xsl:if> 
        <xsl:if test="image6/filename!=''">
          <A HREF="Album_Image6.xsl?AlbumID={albumid}"><IMG BORDER="0" ALIGN="TOP" WIDTH="100" SRC="{image6/filename}"/></A>
          <xsl:text> </xsl:text>
        </xsl:if> 
        <xsl:if test="image7/filename!=''">
          <A HREF="Album_Image7.xsl?AlbumID={albumid}"><IMG BORDER="0" ALIGN="TOP" WIDTH="100" SRC="{image7/filename}"/></A>
          <xsl:text> </xsl:text>
        </xsl:if> 
        <xsl:if test="image8/filename!=''">
          <A HREF="Album_Image8.xsl?AlbumID={albumid}"><IMG BORDER="0" ALIGN="TOP" WIDTH="100" SRC="{image8/filename}"/></A>
          <xsl:text> </xsl:text>
        </xsl:if> 
        <xsl:if test="image9/filename!=''">
          <A HREF="Album_Image9.xsl?AlbumID={albumid}"><IMG BORDER="0" ALIGN="TOP" WIDTH="100" SRC="{image9/filename}"/></A>
        </xsl:if> 
        <!-- Add 5 pixels between column 1 and 2 -->
        <TD WIDTH="5">
        </TD>          
      </TD>
      </xsl:if>
      <!-- Column 2: Album fields -->
      <TD VALIGN="TOP" WIDTH="40%">
        <TABLE CELLPADDING="1" CELLSPACING="1" WIDTH="100%" CLASS="fieldtableprevpane">
          <!-- Artist -->
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              <xsl:value-of select="/data/fld/album/artist/@name"/>:         
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <xsl:call-template name="format-artist">
                <xsl:with-param name="artists" select="artists"/>
                <xsl:with-param name="newwindow" select="'False'"/>
              </xsl:call-template>	
            </TD>
          </TR>
          <!-- Title -->
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              <xsl:value-of select="/data/fld/album/title/@name"/>:         
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <A HREF="Album.xsl?AlbumID={albumid}"  onmouseover="TagToTip('SpanAlbumCredits' {$ToolTipCommands})" onmouseout="UnTip()"><xsl:value-of select="title"/></A>
            </TD>
          </TR>
          <!-- Format -->
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              <xsl:value-of select="/data/fld/album/format/@name"/>:         
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <A HREF="AlbumList.xsl?Format={format}@xmltitle={/data/fld/album/format/@name}: {format}" >
                <xsl:value-of select="format"/>
              </A>
            </TD>
          </TR>
          <!-- Release Year -->
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              <xsl:value-of select="/data/fld/album/released/@name"/>:         
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <A HREF="AlbumList.xsl?Released={released/@year}@xmltitle=Release year: {released/@year}" >
                <xsl:value-of select="released"/>
              </A>
            </TD>
          </TR>
          <!-- Label -->
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              <xsl:value-of select="/data/fld/album/label/@name"/>:         
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <A HREF="AlbumList.xsl?Label={label}@xmltitle={/data/fld/album/label/@name}: {label}" >
                <xsl:value-of select="label"/>
              </A>  
              <xsl:if test="catalognumber!=''">
                <xsl:text> (</xsl:text><xsl:value-of select="catalognumber"/>)
              </xsl:if>
            </TD>
          </TR>
          <!-- Genre -->
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              Genre:         
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <A HREF="AlbumList.xsl?FullGenre={fullgenre}@xmltitle=Genre: {fullgenre}" >
                <xsl:value-of select="fullgenre"/>
              </A>
            </TD>
          </TR>
          <!-- Personal Rating -->
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              Rating:         
            </TD>
            <TD CLASS="fieldvalueprevpane">
              <xsl:if test="personalrating/@image!=''">
                <A HREF="AlbumList.xsl?PersonalRating={personalrating}@xmltitle={/data/fld/album/personalrating/@name}: {personalrating}">
                  <IMG SRC="{personalrating/@image}" BORDER="0"/>                
                </A>                
                <A HREF="CMD:SETRATING:Album,PersonalRating,{albumid/@unformatted}">
                  <IMG SRC="SetRating.gif" BORDER="0"/>
                </A>                
              </xsl:if>   
            </TD>           
          </TR>          
          <!-- Acquirered From -->          
          <xsl:if test="acquiredfrom!=''">
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              <xsl:value-of select="/data/fld/album/acquiredfrom/@name"/>:         
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <A HREF="AlbumList_Acquired.xsl?AcquiredFrom={acquiredfrom}@xmltitle=Acquired From: {acquiredfrom}" > 
                <xsl:value-of select="acquiredfrom"/>
              </A>
            </TD>
          </TR>
          </xsl:if>
          <!-- Date Acquired --> 
          <xsl:if test="dateacquired!=''">         
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              <xsl:value-of select="/data/fld/album/dateacquired/@name"/>:         
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <A HREF="AlbumList_Acquired.xsl?DateAcquired={dateacquired/@unformatted}@xmltitle=Date Acquired: {dateacquired}" > 
                <xsl:value-of select="dateacquired"/>
              </A>
            </TD>
          </TR>
          </xsl:if>
          <!-- Price -->   
          <xsl:if test="price/@unformatted!='0.0'">       
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              <xsl:value-of select="/data/fld/album/price/@name"/>:         
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <xsl:value-of select="price"/>
            </TD>
          </TR>
          </xsl:if>
          <!-- Disc Label -->
          <xsl:if test="disclabel!=''">
          <TR CLASS="fieldrowprevpane">
            <TD CLASS="fieldnameprevpane" NOWRAP="">
              <xsl:value-of select="/data/fld/album/disclabel/@name"/>:           
            </TD>
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">
              <xsl:value-of select="disclabel"/>
            </TD>
          </TR> 
          </xsl:if>                  
          <!-- Notes -->    
          <xsl:if test="notes!=''">        
          <TR CLASS="fieldrowprevpane"> 
            <TD CLASS="fieldnameprevpane" NOWRAP=""> 
              <xsl:value-of select="/data/fld/album/notes/@name"/>:          
            </TD>            
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">               
              <xsl:call-template name="add-line-breaks"> 
                <xsl:with-param name="string" select="notes"/> 
              </xsl:call-template>
            </TD> 
          </TR> 
          </xsl:if>
          <!-- Borrower/Date Borrowed /Due Date --> 
          <xsl:if test="borrower!=''"> 
          <TR CLASS="fieldrowprevpane"> 
            <TD CLASS="fieldnameprevpane" NOWRAP=""> 
              <xsl:value-of select="/data/fld/album/borrower/@name"/>: 
            </TD> 
            <TD CLASS="fieldvalueprevpane" WIDTH="100%"> 
              <A HREF="Borrower.xsl?ID={borrower/@id}" > 
                <xsl:value-of select="borrower"/> 
              </A> 
              <xsl:if test="borrowercategory!=''">              
                <xsl:text> (</xsl:text><xsl:value-of select="borrowercategory"/><xsl:text>)</xsl:text>
              </xsl:if>
            </TD> 
          </TR> 
          <TR> 
            <TD CLASS="fieldnameprevpane" NOWRAP=""> 
              <xsl:value-of select="/data/fld/album/dateborrowed/@name"/>: 
            </TD> 
            <TD CLASS="fieldvalueprevpane" WIDTH="100%"> 
              <xsl:value-of select="dateborrowed"/> 
            </TD>                                  
          </TR> 
          <TR> 
            <TD CLASS="fieldnameprevpane" NOWRAP=""> 
              <xsl:value-of select="/data/fld/album/datedue/@name"/>: 
            </TD>               
            <TD CLASS="fieldvalueprevpane" WIDTH="100%">             
              <xsl:choose>
                <xsl:when test="overdue/@bool='True'">
                  <FONT COLOR="red"><B><xsl:value-of select="datedue"/> </B></FONT>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="datedue"/> 
                </xsl:otherwise>               
              </xsl:choose>              
            </TD>                                  
          </TR> 
          </xsl:if> 
          <!-- Reserved to --> 
          <xsl:if test="reservedto!=''"> 
          <TR CLASS="fieldrowprevpane"> 
            <TD CLASS="fieldnameprevpane" NOWRAP=""> 
              <xsl:value-of select="/data/fld/album/reservedto/@name"/>: 
            </TD> 
            <TD CLASS="fieldvalueprevpane" WIDTH="100%"> 
              <A HREF="Borrower.xsl?ID={reservedto/@id}" > 
                <xsl:value-of select="reservedto"/> 
              </A> 
            </TD> 
          </TR> 
          </xsl:if>          
        </TABLE>
      </TD>
      <!-- Add 3 pixels between column 2 and 3 -->
      <TD WIDTH="3">
      </TD>
      <!-- Column 3: Track list --> 
      <TD VALIGN="TOP" WIDTH="*">
        <TABLE CELLPADDING="1" CELLSPACING="1" WIDTH="100%" CLASS="fieldtableprevpane">
          <xsl:apply-templates select="/data/record/trackdata"/> 
        </TABLE>
      </TD>
    </TR>
  </TABLE>
</xsl:template>

<xsl:template match="trackdata">  
  <xsl:apply-templates select="item"/>
</xsl:template>

<xsl:template match="item">
  <xsl:variable name="itemno">
    <xsl:value-of select="itemno"/>
  </xsl:variable>
  <!-- If more than 1 item, display the item title -->
  <xsl:if test="../@items &gt; 1">
    <TR>
      <TD CLASS="albumdisctitleprevpane" COLSPAN="2">
        <xsl:value-of select="title"/>
      </TD>
    </TR>
  </xsl:if>
  <xsl:apply-templates select="side"/>
</xsl:template>

<xsl:template match="side">
  <xsl:apply-templates select="track"/>
</xsl:template>

<xsl:template match="track"> 
  <TR>
    <TD CLASS="trackrowprevpane" ALIGN="RIGHT" NOWRAP="">            
      <!-- If 2 sides, display the side -->
      <A HREF="Track.xsl?TrackID={@id}">
        <xsl:if test="/data/record/trackdata/@sides = 2">
          <xsl:value-of select="../sideno"/>     
        </xsl:if>
        <xsl:value-of select="index"/>
      </A>.
    </TD>
    <TD CLASS="trackrowprevpane" WIDTH="100%">
      <a href="Track.xsl?ID={@id}" onmouseover="TagToTip('Span{@id}' {$ToolTipCommands})" onmouseout="UnTip()">
        <xsl:value-of select="fulltitle"/>
      </a>
      <xsl:if test="artists/@sort != /data/record/albumdata/artists/@sort">
        <xsl:text> / </xsl:text>
        <I>
          <xsl:call-template name="format-artist">
            <xsl:with-param name="artists" select="artists"/>
            <xsl:with-param name="newwindow" select="'True'"/>
          </xsl:call-template>
        </I>
      </xsl:if>
      <xsl:if test="length/@minutes!='0' or length/@seconds!='0'">
        (<xsl:value-of select="length"/>)
      </xsl:if>
    </TD>
  </TR>
</xsl:template>

<!-- ============================================================= -->
<!-- Below here are several new templates to generate the tooltips -->
<!-- ============================================================= -->
<xsl:template match="track" mode="tooltip">
  <span id="Span{@id}">
    <TABLE WIDTH="{$TrackCreditsWidth}">
      <TR>
        <TD>
          <b><xsl:value-of select="fulltitle"/></b>
          <TABLE CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
            <TR>
              <xsl:if test="count(authorcredits/authorcredit) > 0 or
                count(conductorcredits/conductorcredit) > 0 or 
                count(productioncredits/productioncredit) > 0">
                <TD VALIGN="TOP" WIDTH="50%">
                  <!-- Column 1 -->
                  <TABLE CLASS="fieldtable" CELLSPACING="1" CELLPADDING="2">
                    <!-- Author/Publisher -->        
                    <xsl:if test="count(authorcredits/authorcredit) > 0">
                    <TR> 
                      <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/authorcredit/@name"/></TD>         
                    </TR>  
                    <xsl:apply-templates select="authorcredits" mode="table"/>
                    </xsl:if>
                    <!-- Conductor/Arranger -->
                    <xsl:if test="count(conductorcredits/conductorcredit) > 0">
                    <TR> 
                      <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/conductorcredit/@name"/></TD>
                    </TR>
                    <xsl:apply-templates select="conductorcredits"/>
                    </xsl:if>
                    <!-- Production -->
                    <xsl:if test="count(productioncredits/productioncredit) > 0">
                    <TR> 
                      <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/productioncredit/@name"/></TD>
                    </TR>
                    <xsl:apply-templates select="productioncredits"/>
                    </xsl:if>
                  </TABLE>
                </TD>
                <TD WIDTH="5">
                  <!-- Add 5 pixels between column 1 and 2 -->
                </TD>
                <!-- Add a column here to prevent the layout from being messed up if author/conductor/producer 
                     is specified, but not musician/studio -->
                <xsl:if test="count(bandmembers/bandmember) = 0 and
                  count(guestmusicians/guestmusician) = 0 and 
                  count(studiocredits/studiocredit) = 0">
                  <TD WIDTH="49%">
                  </TD>
                </xsl:if>
              </xsl:if>            
              <xsl:if test="count(bandmembers/bandmember) > 0 or
                count(guestmusicians/guestmusician) > 0 or 
                count(studiocredits/studiocredit) > 0">
                <!-- Column 2 -->
                <TD VALIGN="TOP" WIDTH="49%">        
                  <TABLE CLASS="fieldtable" CELLSPACING="1" CELLPADDING="2">
                    <!-- Production -->
                    <xsl:if test="count(bandmembers/bandmember) > 0">
                    <TR> 
                      <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/bandmember/@name"/></TD>
                    </TR>
                    <xsl:apply-templates select="bandmembers"/>
                    </xsl:if>
                    <!-- Production -->
                    <xsl:if test="count(guestmusicians/guestmusician) > 0">
                    <TR> 
                      <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/guestmusician/@name"/></TD>
                    </TR>
                    <xsl:apply-templates select="guestmusicians"/>
                    </xsl:if>
                    <!-- Production -->
                    <xsl:if test="count(studiocredits/studiocredit) > 0">
                    <TR>
                      <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/studiocredit/@name"/></TD>
                    </TR>
                    <xsl:apply-templates select="studiocredits"/>
                    </xsl:if>
                  </TABLE>
                </TD>
                <!-- Add a column here to prevent the layout from being messed up if musician/studio 
                     is specified, but not author/conductor/producer -->
                <xsl:if test="count(authorcredits/authorcredit) = 0 and
                  count(conductorcredits/conductorcredit) = 0 and 
                  count(productioncredits/productioncredit) = 0">
                  <TD WIDTH="50%">
                  </TD>
                </xsl:if>
              </xsl:if>
            </TR>
          </TABLE>
        </TD>
      </TR>
    </TABLE>
  </span>
</xsl:template>

<xsl:template match="authorcredits" mode="table">
  <xsl:for-each select="authorcredit">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="roles/role">
          <xsl:value-of select="."/>
          <xsl:if test="position() &lt; last()">
            <xsl:text> / </xsl:text>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>

<xsl:template match="conductorcredits">
  <xsl:for-each select="conductorcredit">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="roles/role">
          <xsl:value-of select="."/>
          <xsl:if test="position() &lt; last()">
            <xsl:text> / </xsl:text>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>

<xsl:template match="studiocredits">
  <xsl:for-each select="studiocredit">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname"> 
        <A HREF="Studio_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="roles/role">
          <xsl:value-of select="."/>
          <xsl:if test="position() &lt; last()">
            <xsl:text> / </xsl:text>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>

<xsl:template match="productioncredits">
  <xsl:for-each select="productioncredit">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="roles/role">
          <xsl:value-of select="."/>
          <xsl:if test="position() &lt; last()">
            <xsl:text> / </xsl:text>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>

<xsl:template match="bandmembers">
  <xsl:for-each select="bandmember">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="instruments/instrument">
          <xsl:value-of select="."/>
          <xsl:if test="position() &lt; last()">
            <xsl:text> / </xsl:text>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>

<xsl:template match="guestmusicians">
  <xsl:for-each select="guestmusician">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="instruments/instrument">
          <xsl:value-of select="."/>
          <xsl:if test="position() &lt; last()">
            <xsl:text> / </xsl:text>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>


<xsl:template match="albumdata" mode="tooltip">
  <span id="SpanAlbumCredits">
    <TABLE WIDTH="{$AlbumCreditsWidth}">
      <TR>
        <TD>
          <b><xsl:value-of select="title"/></b>
          <TABLE CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
            <TR>
              <xsl:if test="count(albumauthorcredits/albumauthorcredit) > 0 or
                count(albumconductorcredits/albumconductorcredit) > 0 or 
                count(albumproductioncredits/albumproductioncredit) > 0">
              <!-- Column 1 -->
              <TD VALIGN="TOP" WIDTH="50%">
                <TABLE CLASS="fieldtable" CELLSPACING="1" CELLPADDING="2">
                  <!-- Author/Publisher -->        
                  <xsl:if test="count(albumauthorcredits/albumauthorcredit) > 0">
                  <TR> 
                    <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/authorcredit/@name"/></TD>         
                  </TR>
                  <xsl:apply-templates select="albumauthorcredits"/>
                  </xsl:if>
                  <!-- Conductor/Arranger -->
                  <xsl:if test="count(albumconductorcredits/albumconductorcredit) > 0">
                  <TR> 
                    <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/conductorcredit/@name"/></TD>
                  </TR>
                  <xsl:apply-templates select="albumconductorcredits"/>
                  </xsl:if>
                  <!-- Production -->
                  <xsl:if test="count(albumproductioncredits/albumproductioncredit) > 0">
                  <TR> 
                    <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/productioncredit/@name"/></TD>
                  </TR>
                  <xsl:apply-templates select="albumproductioncredits"/>
                  </xsl:if>
                </TABLE>        
              </TD>      
              <TD WIDTH="5">
                <!-- Add 5 pixels between column 1 and 2 -->
              </TD>
              <!-- Add a column here to prevent the layout from being messed up if author/conductor/producer 
                   is specified, but not musician/studio -->
              <xsl:if test="count(albumbandmembers/albumbandmember) = 0 and
                count(albumguestmusicians/albumguestmusician) = 0 and 
                count(albumstudiocredits/albumstudiocredit) = 0">
              <TD WIDTH="49%">
              </TD>
              </xsl:if>
              </xsl:if>            
              <xsl:if test="count(albumbandmembers/albumbandmember) > 0 or
                count(albumguestmusicians/albumguestmusician) > 0 or 
                count(albumstudiocredits/albumstudiocredit) > 0">
              <!-- Column 2 -->
              <TD VALIGN="TOP" WIDTH="49%">
                <TABLE CLASS="fieldtable" CELLSPACING="1" CELLPADDING="2">        
                  <!-- Band Members -->
                  <xsl:if test="count(albumbandmembers/albumbandmember) > 0">
                  <TR> 
                    <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/bandmember/@name"/></TD>
                  </TR>
                  <xsl:apply-templates select="albumbandmembers"/>
                  </xsl:if>
                  <!-- Guest Musicians -->
                  <xsl:if test="count(albumguestmusicians/albumguestmusician) > 0">
                  <TR> 
                    <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/guestmusician/@name"/></TD>
                  </TR>
                  <xsl:apply-templates select="albumguestmusicians"/>
                  </xsl:if>
                  <!-- Studio -->
                  <xsl:if test="count(albumstudiocredits/albumstudiocredit) > 0">
                  <TR>
                    <TD CLASS="fieldgroup" COLSPAN="2"><xsl:value-of select="/data/fld/track/studiocredit/@name"/></TD>
                  </TR>
                  <xsl:apply-templates select="albumstudiocredits"/>
                  </xsl:if>
                </TABLE>
              </TD>            
              <!-- Add a column here to prevent the layout from being messed up if musician/studio 
                   is specified, but not author/conductor/producer -->
              <xsl:if test="count(albumauthorcredits/albumauthorcredit) = 0 and
                count(albumconductorcredits/albumconductorcredit) = 0 and 
                count(albumproductioncredits/albumproductioncredit) = 0">
              <TD WIDTH="50%">
              </TD>
              </xsl:if>
              </xsl:if>
            </TR>
          </TABLE>
        </TD>
      </TR>
    </TABLE>
  </span>
</xsl:template>

<xsl:template match="albumauthorcredits">
  <xsl:for-each select="albumauthorcredit">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="roles/role">
          <xsl:value-of select="."/>:<BR/>
          <xsl:variable name="credit" select="."/>
          <xsl:variable name="name" select="../../name"/>
          <xsl:apply-templates select="//side/track[authorcredits/authorcredit[roles/role=$credit and name=$name]]" mode="album_tooltip"/>          
          <xsl:if test="position() &lt; last()">
            <BR/>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>  
</xsl:template>

<xsl:template match="albumconductorcredits">
  <xsl:for-each select="albumconductorcredit">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="roles/role">
          <xsl:value-of select="."/>:<BR/>
          <xsl:variable name="credit" select="."/>
          <xsl:variable name="name" select="../../name"/>
          <xsl:apply-templates select="//side/track[conductorcredits/conductorcredit[roles/role=$credit and name=$name]]" mode="album_tooltip"/>
          <xsl:if test="position() &lt; last()">
            <BR/>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>

<xsl:template match="albumstudiocredits">
  <xsl:for-each select="albumstudiocredit">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Studio_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="roles/role">
          <xsl:value-of select="."/>:<BR/>
          <xsl:variable name="credit" select="."/>
          <xsl:variable name="name" select="../../name"/>
          <xsl:apply-templates select="//side/track[studiocredits/studiocredit[roles/role=$credit and name=$name]]" mode="album_tooltip"/>
          <xsl:if test="position() &lt; last()">
            <BR/>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>

<xsl:template match="albumproductioncredits">
  <xsl:for-each select="albumproductioncredit">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="roles/role">
          <xsl:value-of select="."/>:<BR/>
          <xsl:variable name="credit" select="."/>
          <xsl:variable name="name" select="../../name"/>
          <xsl:apply-templates select="//side/track[productioncredits/productioncredit[roles/role=$credit and name=$name]]" mode="album_tooltip"/>
          <xsl:if test="position() &lt; last()">
            <BR/>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>

<xsl:template match="albumbandmembers">
  <xsl:for-each select="albumbandmember">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="instruments/instrument">
          <xsl:value-of select="."/>:<BR/>
          <xsl:variable name="instrument" select="."/>
          <xsl:variable name="name" select="../../name"/>
          <xsl:apply-templates select="//side/track[bandmembers/bandmember[instruments/instrument=$instrument and name=$name]]" mode="album_tooltip"/>
          <xsl:if test="position() &lt; last()">
            <BR/>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>

<xsl:template match="albumguestmusicians">
  <xsl:for-each select="albumguestmusician">
    <TR CLASS="fieldrow">
      <TD CLASS="fieldvaluecreditsname" NOWRAP=""> 
        <A HREF="Person_Albums.xsl?ID={@id}"><xsl:value-of select="name"/></A>
      </TD>
      <TD CLASS="fieldvaluecreditsrole">
        <xsl:for-each select="instruments/instrument">
          <xsl:value-of select="."/>:<BR/>
          <xsl:variable name="instrument" select="."/>
          <xsl:variable name="name" select="../../name"/>
          <xsl:apply-templates select="//side/track[guestmusicians/guestmusician[instruments/instrument=$instrument and name=$name]]" mode="album_tooltip"/>
          <xsl:if test="position() &lt; last()">
            <BR/>
          </xsl:if>    
        </xsl:for-each>
      </TD>
    </TR>
  </xsl:for-each>
</xsl:template>
<xsl:variable name="trackcount" select="count(//side/track)"/>

<xsl:template match="track" mode="album_tooltip">
  <xsl:choose>
    <xsl:when test="$trackcount = last()"> 
      <xsl:if test="position() = 1">
        <A HREF="Album_Tracks.xsl?AlbumID={albumid}">All tracks</A>
      </xsl:if>
    </xsl:when>
    <xsl:otherwise>
      <A HREF="Track.xsl?ID={@id}">
        <xsl:value-of select="title"/>
      </A>
      <xsl:if test="position() &lt; last()">
        <xsl:text> / </xsl:text>
      </xsl:if>    
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>
</xsl:stylesheet>  

